﻿Imports System.Text.Encoding 'From VB Pipe
Public Class Form1
    ' This delegate enables asynchronous calls for setting
    ' the text property on a TextBox control.
    Delegate Sub SetTextCallback(ByVal [text] As String)
    Private Shared mut As New Mutex()


    ' Lets define a bunch of global junk, later should clean up!
    Public fDataHasChanged As Boolean        '
    Public fNewPacketMsgSent As Boolean
    Public fNewPacketMsgMode As Boolean
    Public XBeeCommport As String


    Public XBSW As Stopwatch

    Public PacketHdr(4) As Byte             ' A data packet header

    '    Public Const DATA_PACKET_SIZE = 10  ' Zentas packet size
    Public Const DATA_PACKET_SIZE = 8       ' Kurts packet size

    Public DataPacket(DATA_PACKET_SIZE) As Byte           'XP 8 -> 10
    Public ButtonsState(2) As Byte              ' we will cache the button state here.
    Public Const PKT_BTNLOW = 0                 ' Low Buttons 0-7
    Public Const PKT_BTNHI = 1                  ' High buttons 8-F
    Public Const PKT_RJOYLR = 2                 ' Right Joystick Up/Down
    Public Const PKT_RJOYUD = 3                 ' Right joystick left/Right
    Public Const PKT_LJOYLR = 4                 ' Left joystick Left/Right
    Public Const PKT_LJOYUD = 5                 ' Left joystick Up/Down
    Public Const PKT_RSLIDER = 6                ' right slider
    Public Const PKT_LSLIDER = 7                ' Left slider
    Public Const PKT_RPOT = 8                   ' right potmeter
    Public Const PKT_LPOT = 9                   ' Left potmeter

    ' Now define our different types of packets
    Public Const XBEE_TRANS_READY = &H1         ' Transmitter is ready for requests*
    Public Const XBEE_TRANS_NOTREADY = &H2      ' Transmitter is exiting transmitting on the sent DL
    Public Const XBEE_TRANS_DATA = &H3          ' Data Packet from Transmitter to Robot*
    Public Const XBEE_TRANS_NEW = &H4           ' New Data Available
    Public Const XBEE_TRANS_SSC_MODE = &H5      ' SSC-MODE

    Public Const XBEE_RECV_REQ_DATA = &H80      ' Request Data Packet*
    Public Const XBEE_RECV_REQ_NEW = &H81       ' Request Only New data
    Public Const XBEE_RECV_NEW_THRESH = &H82    ' Set new Data thresholds
    Public Const XBEE_RECV_DISP_VAL = &H83      ' Display a value on line 2

    '========== VB Pipe start =================
    Public Const FILE_ATTRIBUTE_NORMAL = &H80
    Public Const FILE_FLAG_NO_BUFFERING = &H20000000
    Public Const FILE_FLAG_WRITE_THROUGH = &H80000000
    Public Const FILE_FLAG_OVERLAPPED = &H40000000
    Public Const ERROR_OPERATION_ABORTED = 995&
    Public Const ERROR_IO_INCOMPLETE = 996&
    Public Const ERROR_IO_PENDING = 997&

    Public Const PIPE_ACCESS_DUPLEX = &H3
    Public Const PIPE_READMODE_MESSAGE = &H2
    Public Const PIPE_TYPE_MESSAGE = &H4
    Public Const PIPE_WAIT = &H0

    Public Const FILE_BEGIN = 0
    Public Const FILE_CURRENT = 1
    Public Const FILE_END = 2

    Public Const INVALID_HANDLE_VALUE = -1

    Public Const SECURITY_DESCRIPTOR_MIN_LENGTH = (20)
    Public Const SECURITY_DESCRIPTOR_REVISION = (1)

    Public Const INFINITE = -1&

    Private Const QS_KEY = &H1&
    Private Const QS_MOUSEMOVE = &H2&
    Private Const QS_MOUSEBUTTON = &H4&
    Private Const QS_POSTMESSAGE = &H8&
    Private Const QS_TIMER = &H10&
    Private Const QS_PAINT = &H20&
    Private Const QS_SENDMESSAGE = &H40&
    Private Const QS_HOTKEY = &H80&
    Private Const QS_ALLINPUT = (QS_SENDMESSAGE Or QS_PAINT _
             Or QS_TIMER Or QS_POSTMESSAGE Or QS_MOUSEBUTTON _
             Or QS_MOUSEMOVE Or QS_HOTKEY Or QS_KEY)




    Public Structure SECURITY_ATTRIBUTES
        Public nLength As Integer
        Public lpSecurityDescriptor As Integer
        Public bInheritHandle As Integer
    End Structure

    Public Structure OVERLAPPED
        Public Internal As Integer
        Public InternalHigh As Integer
        Public offset As Integer
        Public OffsetHigh As Integer
        Public hEvent As Integer
    End Structure

    Public Const GMEM_FIXED = &H0
    Public Const GMEM_ZEROINIT = &H40
    Public Const GPTR = (GMEM_FIXED Or GMEM_ZEROINIT)

    Declare Function GlobalAlloc Lib "kernel32" ( _
       ByVal wFlags As Integer, ByVal dwBytes As Integer) As Integer
    Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Integer) As Integer
    Declare Function CreateNamedPipe Lib "kernel32" Alias _
       "CreateNamedPipeA" ( _
       ByVal lpName As String, _
       ByVal dwOpenMode As Integer, _
       ByVal dwPipeMode As Integer, _
       ByVal nMaxInstances As Integer, _
       ByVal nOutBufferSize As Integer, _
       ByVal nInBufferSize As Integer, _
       ByVal nDefaultTimeOut As Integer, _
    ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES) As Integer

    Declare Function InitializeSecurityDescriptor Lib "advapi32.dll" ( _
       ByVal pSecurityDescriptor As Integer, _
       ByVal dwRevision As Integer) As Integer

    Declare Function SetSecurityDescriptorDacl Lib "advapi32.dll" ( _
       ByVal pSecurityDescriptor As Integer, _
       ByVal bDaclPresent As Integer, _
       ByVal pDacl As Integer, _
       ByVal bDaclDefaulted As Integer) As Integer

    Declare Function ConnectNamedPipe Lib "kernel32" ( _
        ByVal hNamedPipe As Integer, _
        ByRef lpOverlapped As Overlapped) As Integer

    Declare Function DisconnectNamedPipe Lib "kernel32" ( _
        ByVal hNamedPipe As Integer) As Integer

    Declare Function WriteFile Lib "kernel32" ( _
        ByVal hFile As Integer, _
        ByVal lpBuffer As Byte(), _
        ByVal nNumberOfBytesToWrite As Integer, _
        ByRef lpNumberOfBytesWritten As Integer, _
        ByRef lpOverlapped As Overlapped) As Integer

    Declare Function ReadFile Lib "kernel32" ( _
        ByVal hFile As Integer, _
        ByRef lpBuffer As Byte, _
        ByVal nNumberOfBytesToRead As Integer, _
        ByRef lpNumberOfBytesRead As Integer, _
        ByRef lpOverlapped As Overlapped) As Integer

    Declare Function FlushFileBuffers Lib "kernel32" ( _
        ByVal hFile As Integer) As Integer

    Declare Function CloseHandle Lib "kernel32" ( _
        ByVal hObject As Integer) As Integer

    Declare Function SetFilePointer Lib "kernel32" ( _
        ByVal hFile As Integer, _
        ByVal lDistanceToMove As Integer, _
        ByVal lpDistanceToMoveHigh As Integer, _
        ByVal dwMoveMethod As Integer) As Integer

    Declare Function CreateThread Lib "kernel32" ( _
       ByVal lpSecurityAttributes As Integer, _
       ByVal dwStackSize As Integer, _
       ByVal lpStartAddress As Integer, _
       ByVal lpParameter As Integer, _
       ByVal dwCreationFlags As Integer, _
    ByVal lpThreadId As Integer) As Integer

    Declare Function CreateEvent Lib "kernel32" Alias "CreateEventA" ( _
        ByVal lpEventAttributes As Integer, _
        ByVal bManualReset As Integer, _
        ByVal bInitialState As Integer, _
        ByVal lpName As String) As Integer

    Declare Function WaitForMultipleObjects Lib "kernel32" ( _
        ByVal nCount As Integer, _
        ByVal lpHandles As Integer, _
        ByVal bWaitAll As Integer, _
        ByVal dwMilliseconds As Integer) As Integer

    Declare Function MsgWaitForMultipleObjects Lib "user32" ( _
        ByVal nCount As Integer, _
        ByVal pHandles As Integer, _
        ByVal fWaitAll As Integer, _
        ByVal dwMilliseconds As Integer, _
        ByVal dwWakeMask As Integer) As Integer

    Private pSD As Integer
    Private sa As SECURITY_ATTRIBUTES
    Private hPipe As Integer
    Private Const szPipeName = "\\.\pipe\rrpipe"
    ' size of the pipe buffer used to communicate to/from RR
    Private Const PIPE_BUFFER_SIZE = 4096
    ' buffer size used when reading in variable data
    Private Const DATA_BUFFER = 1024
    ' the maximum length of a variable name to read
    Private Const MAX_VARNAME_SIZE = 64

    ' hold the name used in RR to identify this module
    Private imageName As String
    ' image processed count ... sent back to RR
    Private imageCount As Integer
    ' dimensions of the received image
    Private imageWidth As Integer, imageHeight As Integer
    ' holds the image data
    Private imagePixels() As Byte
    Public RunningWithPipe As Boolean
    Public gbl_hStopEvent As Integer

    Dim variables As New Hashtable

    Private Function intToByte(ByVal i As Integer)

        Dim bArray As Byte() = {i And 255, (i >> 8) And 255, (i >> 16) And 255, (i >> 24) And 255}
        intToByte = bArray

    End Function
    '========= VB Pipe end==============




    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Show all available COM ports.
        Dim rk As RegistryKey = Registry.CurrentUser
        Dim rkXBee As RegistryKey = rk.CreateSubKey("software\XBeeDIYRemote")
        Dim x As Object

        'VBPipe.RunWorkerAsync()
        For Each sp As String In My.Computer.Ports.SerialPortNames
            ComLB.Items.Add(sp)
        Next

        If (ComLB.Items.Count <> 0) Then

            x = rkXBee.GetValue("CommPort")
            If x <> Nothing Then
                ComLB.SelectedIndex = ComLB.FindString(x.ToString)

            Else
                ComLB.SelectedIndex = ComLB.Items.Count - 1
            End If
        End If
        If ComLB.SelectedIndex = -1 Then
            TestSSC.Enabled = False
            Connect.Enabled = False
            Connect_pipe.Enabled = False
            Discover.Enabled = False

        End If
        x = rkXBee.GetValue("ATMY")
        If x <> Nothing Then
            XBeeMy.Text = x.ToString()
        End If

        x = rkXBee.GetValue("ATDL")
        If x <> Nothing Then
            XBeeDL.Text = x.ToString()
        End If
        ' Initialize the state of our cached buttons.
        ButtonsState(0) = 0
        ButtonsState(1) = 0
        fDataHasChanged = False
        fNewPacketMsgSent = False
        fNewPacketMsgMode = False
        RSliderVal.Text = RSlider.Value
        LSliderVal.Text = LSlider.Value
        ' create our timer
        XBSW = New Stopwatch()
        RunningWithPipe = False
        rk.Close()
        rkXBee.Close()


        

    End Sub
    Private Function FConnectToComm()
        ' First thing we try to do is to initialize the XBEE with the appropriate baud rate, My String, etc
        Dim S As String
        Dim fInit As Boolean
        ' first go at high speed of 38400
        Try

            ' First see if we maybe have already initialized the xbee before, if so the baud rate and guard time
            ' will have changed...
            fInit = False
            Debug.Print("Try connect at 38400")
            XBeeCommport = ComLB.Items(ComLB.SelectedIndex)
            Using com1 As IO.Ports.SerialPort = _
                My.Computer.Ports.OpenSerialPort(XBeeCommport, 38400, IO.Ports.Parity.None)
                com1.Handshake = IO.Ports.Handshake.None
                System.Threading.Thread.Sleep(20)
                com1.NewLine = Chr(13)
                com1.Write("+++")
                com1.BaseStream.Flush()
                System.Threading.Thread.Sleep(20)
                com1.Write("ATMY " + XBeeMy.Text + Chr(13))   ' set the MY address
                com1.Write("ATDL " + ExtractXbeeDL(XBeeDL.Text) + Chr(13))   ' set the DL address
                com1.Write("ATCN" + Chr(13))                  ' exit command mode
                com1.BaseStream.Flush()
                ' If we get an OK then we proably init before
                com1.ReadTimeout = 50 'wait a maximum of .05 seconds for a response
                Try
                    S = com1.ReadLine()
                    If S.Length > 0 Then
                        fInit = True    ' hopefully we are now init
                    End If

                Catch ex As Exception
                End Try
            End Using

            If Not fInit Then
                Debug.Print("Try connect at 9600")
                Using com1 As IO.Ports.SerialPort = _
                        My.Computer.Ports.OpenSerialPort(XBeeCommport, 9600, IO.Ports.Parity.None)
                    com1.Handshake = IO.Ports.Handshake.None
                    System.Threading.Thread.Sleep(2000)
                    com1.NewLine = Chr(13)
                    '           com1.WriteLine("+++")
                    com1.NewLine = Chr(13)
                    com1.Write("+++")
                    com1.BaseStream.Flush()

                    System.Threading.Thread.Sleep(2000)  ' have to wait for it to get into command mode...

                    ' now lets output all of the initial stuff.  We probably want to only do this once per time, but...
                    com1.Write("atni  PC DIY Remote" + Chr(13))   ' Set our title
                    com1.Write("ATGT 3" + Chr(13))                ' set the guard time
                    com1.Write("ATMY " + XBeeMy.Text + Chr(13))   ' set the MY address
                    com1.Write("ATDL " + ExtractXbeeDL(XBeeDL.Text) + Chr(13))   ' set the DL address
                    com1.Write("ATBD 5" + Chr(13))             ' set baud rate to 38400 see if we can do this on pc
                    com1.BaseStream.Flush()
                    System.Threading.Thread.Sleep(50)       ' have to wait for it to get into command mode...
                    ' Now we wish to read in all of the responses we got back
                    com1.ReadTimeout = 200 'wait a maximum of .2 seconds for a response
                    Try
ReadLoop:
                        S = com1.ReadLine()
                        If S.Length > 0 Then
                            LCDLB.Items.Add(S)
                            fInit = True    ' we got something...

                            GoTo ReadLoop
                        End If

                    Catch ex As Exception
                    End Try
                    LCDLB.TopIndex = LCDLB.Items.Count - 1

                    com1.Write("ATCN" + Chr(13))                  ' exit command mode
                    com1.BaseStream.Flush()
                    com1.BaudRate = 38400
                End Using
            End If

            Return fInit
        Catch ex As Exception
            Beep()
        End Try
        Return False
        
    End Function



    Private Sub Connect_pipe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Connect_pipe.Click
        If Connect.Text = "Connect" Then
            If FConnectToComm() Then
                Connect.Text = "Pipe&Com active"

                ' Make sure that our packet data is setup properly
                DataPacket(PKT_BTNLOW) = 0      ' assume no buttons pressed
                DataPacket(PKT_BTNHI) = 0
                DataPacket(PKT_LJOYUD) = LJoyUD.Value
                DataPacket(PKT_LJOYLR) = LJoyLR.Value
                DataPacket(PKT_RJOYUD) = RJoyUD.Value
                DataPacket(PKT_RJOYLR) = RJoyLR.Value
                DataPacket(PKT_LSLIDER) = LSlider.Value
                DataPacket(PKT_RSLIDER) = RSlider.Value
                If DATA_PACKET_SIZE >= (PKT_RPOT + 1) Then
                    DataPacket(PKT_LPOT) = 128 'Preset XP just for now
                    DataPacket(PKT_RPOT) = 128
                End If
                VBPipe.RunWorkerAsync()
                'CommThread.RunWorkerAsync()
                TestSSC.Enabled = False
                Connect.Enabled = False
            End If
        Else
            Connect.Text = "Connect"
            'CommThread.CancelAsync()            ' turn off the thread...
            'TestSSC.Enabled = True
        End If

    End Sub

    Private Sub Connect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Connect.Click
        If Connect.Text = "Connect" Then
            If FConnectToComm() Then

                Connect.Text = "Disconnect"

                ' Make sure that our packet data is setup properly
                DataPacket(PKT_BTNLOW) = 0      ' assume no buttons pressed
                DataPacket(PKT_BTNHI) = 0
                DataPacket(PKT_LJOYUD) = LJoyUD.Value
                DataPacket(PKT_LJOYLR) = LJoyLR.Value
                DataPacket(PKT_RJOYUD) = RJoyUD.Value
                DataPacket(PKT_RJOYLR) = RJoyLR.Value
                DataPacket(PKT_LSLIDER) = LSlider.Value
                DataPacket(PKT_RSLIDER) = RSlider.Value
                If DATA_PACKET_SIZE >= (PKT_RPOT + 1) Then
                    DataPacket(PKT_LPOT) = 128 'Preset XP just for now
                    DataPacket(PKT_RPOT) = 128
                End If
                CommThread.RunWorkerAsync()
                TestSSC.Enabled = False
                Connect_pipe.Enabled = False
            End If
        Else
            Connect.Text = "Connect"
            CommThread.CancelAsync()            ' turn off the thread...
            TestSSC.Enabled = True
            Connect_pipe.Enabled = True
        End If

    End Sub


    Private Sub B0_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B0.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) And Not (&H1)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B0_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles B0.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) Or &H1
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B1_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B1.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) And Not (&H2)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles B1.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) Or &H2
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B2_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B2.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) And Not (&H4)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B2_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles B2.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) Or &H4
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B3_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B3.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) And Not (&H8)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B3_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles B3.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) Or &H8
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B4_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B4.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) And Not (&H10)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B4_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles B4.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) Or &H10
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B5_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B5.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) And Not (&H20)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B5_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles B5.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) Or &H20
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B6_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B6.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) And Not (&H40)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B6_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles B6.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) Or &H40
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B7_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B7.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) And Not (&H80)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B7_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles B7.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNLOW) = DataPacket(PKT_BTNLOW) Or &H80
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B8_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B8.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) And Not (&H1)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B8_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles B8.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) Or &H1
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B9_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B9.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) And Not (&H2)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub B9_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles B9.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) Or &H2
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub BA_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BA.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) And Not (&H4)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub BA_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles BA.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) Or &H4
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub BB_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BB.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) And Not (&H8)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub BB_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles BB.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) Or &H8
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub BC_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BC.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) And Not (&H10)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub BC_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles BC.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) Or &H10
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub BD_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BD.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) And Not (&H20)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub BD_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles BD.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) Or &H20
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub BE_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BE.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) And Not (&H40)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub BE_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles BE.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) Or &H40
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub BF_MouseUp(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BF.MouseUp
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) And Not (&H80)
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub BF_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles BF.MouseDown
        mut.WaitOne()
        DataPacket(PKT_BTNHI) = DataPacket(PKT_BTNHI) Or &H80
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub LJOYUD_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles LJoyUD.ValueChanged
        mut.WaitOne()
        LJoyUDVal.Text = LJoyUD.Value - 128
        DataPacket(PKT_LJOYUD) = LJoyUD.Value
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub LJoyLR_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles LJoyLR.ValueChanged
        mut.WaitOne()
        LJoyLRVal.Text = LJoyLR.Value - 128
        DataPacket(PKT_LJOYLR) = LJoyLR.Value
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub RJOYUD_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles RJoyUD.ValueChanged
        mut.WaitOne()
        RJoyUDVal.Text = RJoyUD.Value - 128
        If Not RunningWithPipe Then
            DataPacket(PKT_RJOYUD) = RJoyUD.Value 'temporary Disabled !! VB PIPE =================
        End If
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub RJOYLR_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles RJoyLR.ValueChanged
        mut.WaitOne()
        RJoyLRVal.Text = RJoyLR.Value - 128
        If Not RunningWithPipe Then
            DataPacket(PKT_RJOYLR) = RJoyLR.Value 'temporary Disabled !! VB PIPE =================
        End If
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub LSlider_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles LSlider.ValueChanged
        mut.WaitOne()
        LSliderVal.Text = LSlider.Value
        DataPacket(PKT_LSLIDER) = LSlider.Value
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub RSlider_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles RSlider.ValueChanged
        mut.WaitOne()
        RSliderVal.Text = RSlider.Value
        DataPacket(PKT_RSLIDER) = RSlider.Value
        fDataHasChanged = True
        mut.ReleaseMutex()
    End Sub

    Private Sub RJoyCenter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RJoyCenter.Click
        If RJoyUD.Value <> 128 Or RJoyLR.Value <> 128 Then
            RJoyUD.Value = 128
            RJoyLR.Value = 128
            fDataHasChanged = True
        End If

    End Sub

    Private Sub LJoyCenter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LJoyCenter.Click
        If LJoyUD.Value <> 128 Or LJoyLR.Value <> 128 Then
            LJoyUD.Value = 128
            LJoyLR.Value = 128
            fDataHasChanged = True
        End If

    End Sub
    Public Sub ClearInputBuffer(ByRef com1 As IO.Ports.SerialPort)
        Dim cbRead As Byte
        Dim b(1) As Byte

        com1.DiscardInBuffer()    ' flush out anything we have
        cbRead = 1
        com1.ReadTimeout = 100 'wait a maximum of .1 seconds for a response
        Try
            While cbRead > 0
                cbRead = com1.Read(b, 0, 1)
            End While

        Catch ex As Exception

        End Try

    End Sub

    '==============================================================================
    ' [SendXBeePacket] function
    '   We will try to funnel all of our writes through this function such that
    '   we can experiment with change to binary...
    '  
    '==============================================================================

    Public Sub SendXBeePacket(ByRef com1 As IO.Ports.SerialPort, ByVal bPHType As Byte, ByVal bSeq As Byte, ByVal cbExtra As Byte, ByRef pbextra As Byte())
        ' local variables
        Dim wChkSum As UShort       ' unsigned
        Dim bTemp(20) As Byte
        Dim bDataPacket(DATA_PACKET_SIZE + 4) As Byte

        bDataPacket(0) = bPHType            ' Command type
        bDataPacket(2) = bSeq               ' Sequence number
        bDataPacket(3) = cbExtra            ' XP 8 -> 10 extra bytes
        wChkSum = bDataPacket(2)
        wChkSum += bDataPacket(3)
        If cbExtra Then
            For i = 0 To (cbExtra - 1)
                bDataPacket(i + 4) = pbextra(i)
                wChkSum += pbextra(i)
            Next
        End If

        bDataPacket(1) = wChkSum And &HFF
        com1.Write(bDataPacket, 0, cbExtra + 4)                       ' Ok lets write out the data. XP 12 -> 14
        com1.BaseStream.Flush()                             ' Make sure it goes out now
    End Sub



    '==============================================================================
    ' [CheckAndTransmitDataPacket] function
    ' 
    ' This function will output a packet of data over the XBee to the receiving robot.  This function
    ' will start off simple and simply dump the raw data.  Then I will build in additional smarts.  Things like:
    ' only transmit data if it has changed.  Maybe allow the remote robot be able to send us information like
    ' how much slop should we allow in the deadband range for each channel.  Also Maybe we need to generate
    ' a pulse to allow the other side know that we are still there...
    '==============================================================================

    ''
    Public Sub CheckAndTransmitDataPacket(ByRef com1 As IO.Ports.SerialPort)

        '
        ' local variables
        Dim CMDPacket(4) As Byte
        Dim wChkSum As UShort       ' unsigned
        Dim bTemp(20) As Byte
        Dim bDataPacket(DATA_PACKET_SIZE + 4) As Byte
        Dim cbRead As Byte

        ' We will first check to see if there is someone out there who is waiting for this data.
        ' They will send us a simple prompt that they want data, at which time we will send out our next
        ' packet of data.
        Try
            If com1.BytesToRead > 0 Then
                ' Read in the cmd header.  We expect that the cmd packet will look like:
                ' CmdPacket(0) = XBEE_RECV_REQ_DATA
                ' CmdPacket(1) = Checksum
                ' CmdPacket(2) = sequence Number
                ' CmdPacket(3) = Count of extra data in this case 0
                com1.ReadTimeout = 50 'wait a maximum of .05 seconds for a response
                cbRead = 0
                Do
                    cbRead += com1.Read(CMDPacket, cbRead, 4 - cbRead)
                Loop Until cbRead = 4


                ' Validate the packet. If A data request, it should be simple
                ' Simple request, no extra data, so checksum should equal the packet number...
                If (CMDPacket(0) = XBEE_RECV_REQ_DATA) And (CMDPacket(1) = CMDPacket(2)) And (CMDPacket(3) = 0) Then
                    ' First lets generate the checksum
                    ' make sure we are the only one touching the packet
                    mut.WaitOne()
                    ' Lets build it all into one buffer to output, so we can free up the other thread to change things
                    ' Output the packet data
                    ' Packet(0) = XBEE_TRANS_DATA
                    ' Packet(1) = Checksum
                    ' Packet(2) = Sequence Number in here from request
                    ' Packet(3) = 8	' 8 extra bytes
                    ' extra data...
                    SendXBeePacket(com1, XBEE_TRANS_DATA, CMDPacket(2), DATA_PACKET_SIZE, DataPacket)
                    fDataHasChanged = False                                               ' Clear out that we have new data.
                    fNewPacketMsgSent = False                                               ' We have not sent a new Msg since the last data
                    mut.ReleaseMutex()

                    XBSW.Reset()                                        ' reset our stop watch back to zero
                    XBSW.Start()
                    ' Next check for the packet may be a Req New which changes when we transmite data...	
                ElseIf (CMDPacket(0) = XBEE_RECV_REQ_NEW) Then
                    If (CMDPacket(1) = CMDPacket(2)) And (CMDPacket(3) = 0) Then

                        ' Ok valid, if Zero for packet number then back to normal mode else we go into mode where we will tell them when new data is available.
                        fNewPacketMsgMode = (CMDPacket(1) <> 0)
                    End If

                ElseIf (CMDPacket(0) = XBEE_RECV_DISP_VAL) Then
                    ' Try to handle both text and a simple byte value passed to us...
                    If (CMDPacket(3) > 0) And (CMDPacket(3) <= 16) Then
                        ' They passed us a string, so lets get that and display it. 
                        cbRead = 0
                        Do
                            cbRead += com1.Read(bTemp, cbRead, CMDPacket(3) - cbRead)
                        Loop Until cbRead = CMDPacket(3)

                        ' Build checksum
                        wChkSum = CMDPacket(2) + CMDPacket(3)   '
                        For i = 0 To CMDPacket(3) - 1
                            wChkSum = wChkSum + bTemp(i)
                        Next
                        If (wChkSum And &HFF) = CMDPacket(1) Then
                            DisplayRemoteString(bTemp, CMDPacket(3))
                        End If
                    ElseIf (CMDPacket(1) = CMDPacket(2)) And (CMDPacket(3) = 0) Then
                        DisplayRemoteValue(CMDPacket(2))
                    End If
                Else
                    'We got something we were not expecting so error out.	
                    System.Threading.Thread.Sleep(250)  ' Sleep for a bit to hopefully get the gunk out.
                    ClearInputBuffer(com1)
                End If
            End If

        Catch e As TimeoutException


        End Try

        ' Do we have new data to tell the client about?
        If fNewPacketMsgMode And fDataHasChanged And (fNewPacketMsgSent = 0) Then

            ' We are in new msg mode and the data has changed and we have not told the client about it yet
            SendXBeePacket(com1, XBEE_TRANS_NEW, 0, 0, bDataPacket)     ' pass dummy string pointer... not used
            fNewPacketMsgSent = True
        End If


        ' we did not get anything or we did not get a complet packet...
        If XBSW.ElapsedMilliseconds() > 2000 Then
            'We got something we were not expecting so error out.	
            ClearInputBuffer(com1)
            XBeeTransReady(com1)            ' send out another ready signal.
        End If
        Return
    End Sub



    '==============================================================================
    ' [XBeeTransReady] - Simple message that we send out when we are ready
    '		or if we have not received anything for a long time...
    '
    '		This packet currently our MY that the destination will use to
    '		talk back to us, such that we can have multiple transmitters.
    '==============================================================================

    Public Sub XBeeTransReady(ByRef com1 As IO.Ports.SerialPort)
        Dim bMy(2) As Byte
        Dim wXbee As Short
        ' first need to get MY and convert to a number
        wXbee = Int16.Parse(XBeeMy.Text, Globalization.NumberStyles.HexNumber)  '
        bMy(0) = wXbee >> 8            ' high byte
        bMy(1) = wXbee And &HFF        ' low byte
        SendXBeePacket(com1, XBEE_TRANS_READY, 0, 2, bMy)

        XBSW.Reset()                    ' reset our stop watch back to zero
        XBSW.Start()
        fNewPacketMsgSent = False       ' give it a chance to send again...
    End Sub


    '==============================================================================
    ' [XBeeTransNotReady] - Simple message that we send out when are no longer ready
    '		to receive anything.  Such as we are in some configuration menu...
    '		especially if we may change our MY setting...
    '
    '		This packet currently has no extra data.
    '==============================================================================

    Public Sub XBeeTransNotReady(ByRef com1 As IO.Ports.SerialPort)
        Dim b(1) As Byte
        SendXBeePacket(com1, XBEE_TRANS_NOTREADY, 0, 0, b)
    End Sub


    Public Sub AddItemToLB(ByVal text As String)
        LCDLB.Items.Add(text)
        LCDLB.TopIndex = LCDLB.Items.Count - 1
    End Sub

    '==============================================================================
    ' [DisplayRemoteString (pStr, cbStr)]
    ' 
    ' This function takes care of displaying string and or a number sent to us 
    ' rom the remote robot.  For now hard coded to a specific location on line 2...
    '
    ' This function will also switch to the appropriate display mode if necessary.
    '==============================================================================
    Public Sub DisplayRemoteString(ByRef pstr() As Byte, ByVal cbStr As Byte)
        ' Make sure we are in the right mode to display the data

        If cbStr Then
            Dim s As String
            Dim i As Byte
            s = Chr(pstr(0))
            For i = 1 To cbStr - 1
                s = s + Chr(pstr(i))
            Next
            If LCDLB.InvokeRequired Then
                Dim d As New SetTextCallback(AddressOf AddItemToLB)
                Me.Invoke(d, New Object() {s})
            Else
                LCDLB.Items.Add(s)
                LCDLB.TopIndex = LCDLB.Items.Count - 1

            End If
        End If
        Return
    End Sub



    '==============================================================================
    ' [DisplayRemoteValue (num)]
    ' 
    ' This function takes care of displaying a number sent to us 
    ' rom the remote robot.  For now hard coded to a specific location on line 2...
    '
    ' This function will also switch to the appropriate display mode if necessary.
    '==============================================================================
    Public Sub DisplayRemoteValue(ByVal bVal As Byte)
        ' Make sure we are in the right mode to display the data

        ' now display the value - For now one or the other.
        'gosub DoLCDDisplay[13, 2, 0, bVal]

        Return
    End Sub



    Private Sub CommThread_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles CommThread.DoWork

        CommThread.ReportProgress(0)
        XBSW.Start()
        'Dim Counter As Byte



        Using com1 As IO.Ports.SerialPort = _
            My.Computer.Ports.OpenSerialPort(XBeeCommport, 38400, IO.Ports.Parity.None)
            com1.Handshake = IO.Ports.Handshake.None
            com1.DtrEnable = False
            com1.NewLine = Chr(13)

            While Not CommThread.CancellationPending              ' turn off the thread...

                CheckAndTransmitDataPacket(com1)                ' just loop trying to send packets


            End While

            XBeeTransNotReady(com1)            ' send out a not ready in case it was waiting for us

        End Using


        CommThread.ReportProgress(99)

    End Sub


    Private Sub CommThread_ProgressChanged(ByVal sender As Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles CommThread.ProgressChanged
        If e.ProgressPercentage < 10 Then
            LCDLB.Items.Add("*** Thread Start ***")
            LCDLB.TopIndex = LCDLB.Items.Count - 1
        ElseIf e.ProgressPercentage > 90 Then
            LCDLB.Items.Add("*** Thread Canceled ***")
            LCDLB.TopIndex = LCDLB.Items.Count - 1
        End If
    End Sub

    Private Sub ComLB_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComLB.SelectedIndexChanged
        ' Show all available COM ports.
        Dim rk As RegistryKey = Registry.CurrentUser
        Dim rkXBee As RegistryKey = rk.CreateSubKey("software\XBeeDIYRemote")

        If (ComLB.SelectedIndex >= 0) Then
            rkXBee.SetValue("CommPort", ComLB.Items(ComLB.SelectedIndex).ToString)
            TestSSC.Enabled = True
            Connect.Enabled = True
            Connect_pipe.Enabled = True
            Discover.Enabled = True
        Else
            ' nothing selected, disable a few controls.
            TestSSC.Enabled = False
            Connect.Enabled = False
            Discover.Enabled = False
        End If
        rkXBee.Close()
        rk.Close()

    End Sub

    Private Sub XBeeMy_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles XBeeMy.TextChanged
        Dim rk As RegistryKey = Registry.CurrentUser
        Dim rkXBee As RegistryKey = rk.CreateSubKey("software\XBeeDIYRemote")

        rkXBee.SetValue("ATMY", XBeeMy.Text)
        rkXBee.Close()
        rk.Close()

    End Sub
    Private Function ExtractXbeeDL(ByRef s As String)
        ' This function will look through the string that is shown and only return back the part at the beginning that is a hex number.  This
        ' is needed as we now popuplate a drop down list with the robot names we discovered.
        Dim i As Short
        Dim c As Char
        If s.Length = 0 Then
            Return String.Empty
        End If
        For i = 0 To (s.Length - 1)
            c = s.Substring(i, 1)
            If (c >= "0" And c <= "9") Or (c >= "a" And c <= "f") Or (c >= "A" And c <= "F") Then
                ' valid char should turn this around
            Else
                If i <> 0 Then
                    Return s.Substring(0, i)
                Else
                    Return String.Empty
                End If
            End If
        Next
        Return s ' whole string is valid...
    End Function

    Private Sub XBeeDL_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles XBeeDL.TextChanged
        Dim rk As RegistryKey = Registry.CurrentUser
        Dim rkXBee As RegistryKey = rk.CreateSubKey("software\XBeeDIYRemote")

        rkXBee.SetValue("ATDL", XBeeDL.Text)
        rkXBee.Close()
        rk.Close()
    End Sub


    Private Sub TestSSC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TestSSC.Click
        Dim s As String
        Dim i As Byte
        Dim b(1) As Byte

        If FConnectToComm() Then
            Debug.Print("Worked now open at our 38400 to do communication")
            System.Threading.Thread.Sleep(500)  ' have to wait for it to get into command mode...
            Beep()
            Using com1 As IO.Ports.SerialPort = _
                    My.Computer.Ports.OpenSerialPort(XBeeCommport, 38400, IO.Ports.Parity.None)
                System.Threading.Thread.Sleep(20)
                com1.NewLine = Chr(13)
                com1.Write("+++")
                com1.BaseStream.Flush()
                System.Threading.Thread.Sleep(20)
                com1.Write("ATMY" + Chr(13))   ' set the MY address
                com1.Write("ATDL" + Chr(13))   ' set the DL address
                com1.Write("ATCN" + Chr(13))                  ' exit command mode
                com1.BaseStream.Flush()
                ' If we get an OK then we proably init before
                com1.ReadTimeout = 50 'wait a maximum of .05 seconds for a response
                Try
                    Do
                        s = com1.ReadLine()
                        If s.Length > 0 Then
                            LCDLB.Items.Add(s)
                        End If

                    Loop While s.Length > 0

                Catch ex As Exception
                End Try
                LCDLB.TopIndex = LCDLB.Items.Count - 1

                ' We now need to tell the other side to enter ssc emulation mode
                ClearInputBuffer(com1)
                XBeeTransReady(com1)
                System.Threading.Thread.Sleep(500)

                SendXBeePacket(com1, XBEE_TRANS_SSC_MODE, 0, 0, b)
                System.Threading.Thread.Sleep(500)

                For i = 1 To 10
                    com1.Write("VER" + Chr(13))
                    com1.ReadTimeout = 100
                    Try
                        s = com1.ReadLine()
                        Debug.Print(s)

                    Catch ex As Exception

                    End Try
                    System.Threading.Thread.Sleep(100)
                Next

            End Using
        End If

    End Sub

    Private Sub Discover_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Discover.Click
        Dim s As String

        If FConnectToComm() Then

            Using com1 As IO.Ports.SerialPort = _
                    My.Computer.Ports.OpenSerialPort(XBeeCommport, 38400, IO.Ports.Parity.None)
                Dim cItems As Short

                com1.Handshake = IO.Ports.Handshake.None
                System.Threading.Thread.Sleep(20)
                com1.NewLine = Chr(13)
                com1.Write("+++")
                com1.BaseStream.Flush()
                System.Threading.Thread.Sleep(20)
                com1.BaseStream.Flush()
                ' If we get an OK then we proably init before
                com1.ReadTimeout = 50 'wait a maximum of .05 seconds for a response
                Try
                    s = com1.ReadLine()

                    ' Now lets see if we discover Nodes to maybe talk to.
                    com1.Write("ATND" + Chr(13))
                    com1.BaseStream.Flush()

                    ' Now for each Transmitter out there we are expecting to receive so many lines of input.
                    com1.ReadTimeout = 3000 'wait a maximum of 3 seconds for a response
                    cItems = LCDLB.Items.Count
                    While True
                        Dim sMy As String
                        Dim sSH As String
                        Dim sSL As String
                        Dim sDB As String
                        Dim sNI As String

                        sMy = com1.ReadLine()   ' My
                        If sMy.Length = 0 Then
                            Exit While
                        End If
                        sSH = com1.ReadLine()   ' High Serial Number
                        sSL = com1.ReadLine()   ' Low serial number
                        sDB = com1.ReadLine()   ' DB
                        sNI = com1.ReadLine()   ' Should Have the text string
                        s = com1.ReadLine()     ' should simply be empty
                        XBeeDL.Items.Add(sMy + " - " + sNI)
                    End While
                    LCDLB.TopIndex = cItems
                Catch ex As Exception
                    LCDLB.Items.Add("Catch Error?")
                End Try
            End Using
            LCDLB.TopIndex = LCDLB.Items.Count - 1


        End If

    End Sub
    '=======================================================================================================
    'Pipe plugin
    ' read in an integer from the pipe. Since we read in bytes we need to change those bytes to
    ' their integer counterparts.
    Private Function ReadInteger(ByRef hPipe)

        Dim bytesRead As Integer
        Dim data As Byte() = {0, 0, 0, 0}
        bytesRead = 4

        ReadFile(hPipe, data(0), 4, bytesRead, Nothing)

        ReadInteger = data(0) Or (data(1) * 256) Or (data(2) * 65536) Or (data(3) * 16777216)

    End Function


    ' returns an error message to RR. This message is displayed in the "messages" list within
    ' the RR Pipe Program interface.
    Private Sub ReturnError(ByVal hPipe As Long, ByRef txt As String)

        Dim bytesWrite As Long
        Dim writeLen As Integer
        Dim txtBytes As Byte()
        Dim dataLen As Integer

        writeLen = 5
        ' write the message name
        WriteFile(hPipe, intToByte(writeLen), 4, bytesWrite, Nothing)
        WriteFile(hPipe, ASCII.GetBytes("error"), writeLen, bytesWrite, Nothing)
        ' write the message data
        dataLen = Len(txt)
        txtBytes = ASCII.GetBytes(txt)
        WriteFile(hPipe, intToByte(dataLen), 4, bytesWrite, Nothing)
        WriteFile(hPipe, txtBytes, dataLen, bytesWrite, Nothing)

    End Sub

    ' returns a byte string variable to RR. The returned variables can be used
    ' elsewhere in RR for continued processing.
    Private Sub ReturnBytesVariable(ByVal hPipe As Long, ByRef name As String, ByRef data As Byte(), ByVal dataLen As Long)

        Dim bytesWrite As Long
        Dim writeLen As Integer
        writeLen = Len(name)
        Dim varData As Byte()

        varData = ASCII.GetBytes(name)

        ' write the message name
        WriteFile(hPipe, intToByte(writeLen), 4, bytesWrite, Nothing)
        WriteFile(hPipe, varData, writeLen, bytesWrite, Nothing)
        ' write the message data
        WriteFile(hPipe, intToByte(dataLen), 4, bytesWrite, Nothing)
        If dataLen > 0 Then
            WriteFile(hPipe, data, dataLen, bytesWrite, Nothing)
        End If

    End Sub

    Private Sub ReturnIntVariable(ByVal hPipe As Long, ByRef name As String, ByVal data As Long)

        Dim bytesWrite As Long
        Dim dataLen As Integer
        Dim dataBytes As Byte()
        Dim dataText As String

        Dim varData As Byte()

        varData = ASCII.GetBytes(name)

        dataText = CStr(data)
        dataBytes = ASCII.GetBytes(dataText)

        dataLen = Len(name)
        ' write the message name
        WriteFile(hPipe, intToByte(dataLen), 4, bytesWrite, Nothing)
        WriteFile(hPipe, varData, dataLen, bytesWrite, Nothing)
        ' write the message data
        dataLen = Len(dataText)
        WriteFile(hPipe, intToByte(dataLen), 4, bytesWrite, Nothing)
        WriteFile(hPipe, dataBytes, dataLen, bytesWrite, Nothing)

    End Sub

    ' Parses the variables sent by RR into the appropriate structure. You can add
    ' your own processing routines here to handle other variables that may get sent.
    Private Sub ProcessVariable(ByVal hPipe As Long, ByRef name As Byte(), ByRef data As Byte(), ByVal dataLen As Long)

        Dim strName As String
        Dim strCogData As String
        Dim bData As Byte


        'System.Threading.Thread.Sleep(50) 'just a test
        strName = ASCII.GetString(name)

        ' determine what we've got
        If strName = "name" Then
            imageName = ASCII.GetString(data)
            imageName = imageName.Substring(0, dataLen)
            ' determine what we've got
        ElseIf strName = "width" Then
            imageWidth = data(0) + (data(1) * 256)
            'Debug.Print(imageWidth)

        ElseIf strName = "height" Then
            imageHeight = data(0) + (data(1) * 256)

        ElseIf strName = "image" Then
            If imageWidth = 0 Or imageHeight = 0 Then
                ReturnError(hPipe, "Error - missing image dimensions before image data!")
                End
            End If

            If dataLen <> CLng(imageWidth) * CLng(imageHeight) * 3 Then
                ReturnError(hPipe, "Error - length of data and dimensions of image" & vbCrLf & "           disagree! (width:" & imageWidth & " height:" & imageHeight & " len:" & dataLen & ")" & vbCrLf)
                End
            End If

            ReDim imagePixels(dataLen)

            ' we did not read in the image data yet since it is always > 1024 ..
            Dim bytesRead = 0
            ReadFile(hPipe, imagePixels(0), dataLen, bytesRead, Nothing)

        ElseIf strName = "COG_X" Then
            'Debug.Print(strName)
            strCogData = ASCII.GetString(data)
            strCogData = strCogData.Substring(0, dataLen)
            If imageWidth > 0 Then
                bData = (Val(strCogData) * 255) / imageWidth
            End If
            DataPacket(PKT_RJOYLR) = 128 - ((bData - 128) / 2)
            fDataHasChanged = True
            Debug.Print(bData)
            'CogX.Text = DataPacket(PKT_RJOYLR)


        ElseIf strName = "COG_Y" Then
            'Debug.Print(strName)
            strCogData = ASCII.GetString(data)
            strCogData = strCogData.Substring(0, dataLen)
            If imageHeight > 0 Then
                bData = (Val(strCogData) * 255) / imageHeight
            End If
            DataPacket(PKT_RJOYUD) = 128 - ((bData - 128) / 2)
            fDataHasChanged = True

            'CogY.Text = DataPacket(PKT_RJOYUD)
            Debug.Print(bData)


        Else
            ' skip this variable
            If dataLen > DATA_BUFFER Then
                ' only need to skip bytes if we have not read it in yet
                SetFilePointer(hPipe, dataLen, 0, FILE_CURRENT)
            Else
                Dim strData As String
                strData = ASCII.GetString(data)
                strData = strData.Substring(0, dataLen)
                variables.Item(strName) = strData
            End If
        End If

    End Sub

    ' Performs the image conversion/processing/etc that you want to perform
    Sub Process()

        Dim i As Long
        Dim tmp As Byte
        Dim w As Long

        ' you can access any variables using
        'variables.Item("name")
        'MsgBox(variables.Item("COG_X"))
        ' msgbox variables.item("COG_Y")

        ' remember that we're working in RGB color ... so the actual width is 3x
        w = imageWidth * 3

        ' sanity check
        If imageWidth = 0 Or imageHeight = 0 Then Exit Sub

        ' you could check imageName to perform different analysis in the same
        ' program ....

        ' as an example ... swap red and blue values
        For i = 0 To ((w * imageHeight) - 3) Step 3
            ' image format is RGB ... first byte is red
            tmp = imagePixels(i)
            ' swap red and blue
            imagePixels(i) = imagePixels(i + 2)
            imagePixels(i + 2) = tmp
        Next

        ' note this this is an inplace filter so you don't need an additional image array
        ' but you've now corrupted the original image ...

    End Sub

    Private Sub VBPipe_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles VBPipe.DoWork
        VBPipe.WorkerReportsProgress = True
        VBPipe.ReportProgress(0)
        VBPipe.WorkerSupportsCancellation = True
        Dim dwOpenMode As Integer, dwPipeMode As Integer
        Dim res As Integer, bytesRead As Integer, varLen As Integer
        Dim varName() As Byte
        Dim varData(1024) As Byte

        RunningWithPipe = True

        'Create the NULL security token for the pipe
        pSD = GlobalAlloc(GPTR, SECURITY_DESCRIPTOR_MIN_LENGTH)
        res = InitializeSecurityDescriptor(pSD, SECURITY_DESCRIPTOR_REVISION)
        res = SetSecurityDescriptorDacl(pSD, -1, 0, 0)
        sa.nLength = Len(sa)
        sa.lpSecurityDescriptor = pSD
        sa.bInheritHandle = True

        Dim op As OVERLAPPED

        Dim eventHandle As Long
        eventHandle = CreateEvent(0&, False, False, 0&)
        op.hEvent = eventHandle

        'Create the Named Pipe
        dwOpenMode = PIPE_ACCESS_DUPLEX Or FILE_FLAG_WRITE_THROUGH
        'dwPipeMode = FILE_FLAG_OVERLAPPED Or PIPE_TYPE_MESSAGE Or PIPE_READMODE_MESSAGE
        dwPipeMode = PIPE_TYPE_MESSAGE Or PIPE_READMODE_MESSAGE
        hPipe = CreateNamedPipe(szPipeName, dwOpenMode, dwPipeMode, 10, 10000, 2000, 10000, sa)

        '===========Test com start=======:
        XBSW.Start()
        Using com1 As IO.Ports.SerialPort = _
                My.Computer.Ports.OpenSerialPort(XBeeCommport, 38400, IO.Ports.Parity.None)
            com1.Handshake = IO.Ports.Handshake.None
            com1.DtrEnable = False
            com1.NewLine = Chr(13)
            VBPipe.ReportProgress(10)
            '===
            Do While Not VBPipe.CancellationPending

                'Waiting
                VBPipe.ReportProgress(20)
                res = ConnectNamedPipe(hPipe, Nothing)

                'res = MsgWaitForMultipleObjects(1, eventHandle, 0&, INFINITE, QS_ALLINPUT)

                If res > 0 Then
                    VBPipe.ReportProgress(22)
                    'Connected

                    imageCount = 0

                    Dim bytesWrite = 0

                    varLen = 0

                    Do While Not VBPipe.CancellationPending

                        imageCount = imageCount + 1

                        'Processing  & imageCount

                        Do While Not VBPipe.CancellationPending

                            'DoEvents()

                            ' read in variable length
                            varLen = ReadInteger(hPipe)
                            ' if length <=0 on the variable name then we're done
                            If varLen <= 0 Then Exit Do
                            ' read in variable name but if the name is longer than 64 characters
                            ' then grab the first 64 chars only
                            If varLen < MAX_VARNAME_SIZE Then
                                bytesRead = varLen
                                ReDim varName(varLen - 1)
                                ReadFile(hPipe, varName(0), varLen, bytesRead, Nothing)
                            Else
                                bytesRead = 64
                                ' read in first 64 chars
                                ReDim varName(64 - 1)
                                ReadFile(hPipe, varName(0), MAX_VARNAME_SIZE - 1, bytesRead, Nothing)
                                ' skip over remaining chars
                                SetFilePointer(hPipe, varLen - MAX_VARNAME_SIZE + 1, 0, FILE_CURRENT)
                            End If

                            ' read in the variable's data length
                            varLen = ReadInteger(hPipe)
                            ' if the data is less than 1024 read it in now ..
                            If varLen < 1024 Then
                                bytesRead = varLen
                                ReadFile(hPipe, varData(0), varLen, bytesRead, Nothing)
                            End If

                            ' handle this variable

                            ProcessVariable(hPipe, varName, varData, varLen)
                            CheckAndTransmitDataPacket(com1)        ' just loop trying to send packets
                            VBPipe.ReportProgress(50) 'Write out the Cog data to txtbox
                        Loop

                        ' termination signal -1 on attribute length
                        If varLen < 0 Then Exit Do

                        ' process image
                        Process()

                        ' Write out the processed image back to RoboRealm using stdout.
                        ' You can also write back any other variables to use in
                        ' other parts of the program.
                        ' The format is the same as the input.
                        ReturnBytesVariable(hPipe, CStr("image"), imagePixels, CLng(imageWidth) * CLng(imageHeight) * 3)

                        ' Send back the count as an example of how to feed back variables into RoboRealm
                        ReturnIntVariable(hPipe, "count", imageCount)

                        ' write out end of message
                        WriteFile(hPipe, ASCII.GetBytes(""), 4, bytesWrite, Nothing)
                        FlushFileBuffers(hPipe)


                        If bytesWrite <= 0 Then Exit Do


                        ' continue by waiting for next image request
                    Loop

                    'Disconnected

                    ' signal end of stream
                    Dim eos
                    eos = -1
                    WriteFile(hPipe, intToByte(varLen), 4, bytesWrite, Nothing)
                    FlushFileBuffers(hPipe)

                    DisconnectNamedPipe(hPipe)


                    'If varLen < 0 Then Exit Do
                    Exit Do 'End thread after disconnection of Pipe
                End If
            Loop
            XBeeTransNotReady(com1)            ' send out a not ready in case it was waiting for us
            VBPipe.ReportProgress(90)

        End Using
        'Exiting"

        'Close the pipe handle
        CloseHandle(hPipe)
        GlobalFree(pSD)
        VBPipe.ReportProgress(99)
        RunningWithPipe = False

    End Sub



    Private Sub VBPipe_ProgressChanged(ByVal sender As Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles VBPipe.ProgressChanged
        If e.ProgressPercentage < 10 Then
            LCDLB.Items.Add("*** VBPipe work started ***")
        ElseIf e.ProgressPercentage = 10 Then
            LCDLB.Items.Add("*** Com active ***")
        ElseIf e.ProgressPercentage = 20 Then
            LCDLB.Items.Add("*** VBPipe waiting ***")
        ElseIf e.ProgressPercentage = 22 Then
            LCDLB.Items.Add("*** VBPipe active ***")
        ElseIf e.ProgressPercentage = 50 Then
            CogX.Text = DataPacket(PKT_RJOYLR)
            CogY.Text = DataPacket(PKT_RJOYUD)
        ElseIf e.ProgressPercentage = 90 Then
            LCDLB.Items.Add("*** Com disconnected ***")
        ElseIf e.ProgressPercentage = 99 Then
            LCDLB.Items.Add("*** VBPipe closed ***")

        End If
        LCDLB.TopIndex = LCDLB.Items.Count - 1

    End Sub


    Private Sub VBPipe_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles VBPipe.RunWorkerCompleted
        ' First, handle the case where an exception was thrown.
        If (e.Error IsNot Nothing) Then
            MessageBox.Show(e.Error.Message)
        ElseIf e.Cancelled Then
            ' Next, handle the case where the user canceled the 
            ' operation.
            ' Note that due to a race condition in 
            ' the DoWork event handler, the Cancelled
            ' flag may not have been set, even though
            ' CancelAsync was called.
            LCDLB.Items.Add("VBPipe Canceled")
        End If
        Connect.Enabled = True
        Connect_pipe.Enabled = True
        Connect.Text = "Connect"
    End Sub
End Class


